/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
Refer NOTE in section 11.4.1, about the behaviour of the delete operator in strict mode.
*/

var testName = "delete operator throws ReferenceError when deleting a direct reference to a var in strict mode";

function testcase() {
  'use strict';

  var x;

  // Now, deleting 'x' directly should fail throwing a ReferenceError
  // because 'x' evaluates to a strict reference;
  try {
    delete x;
  }
  catch (e) {
    if (e instanceof ReferenceError) {
      return true;
    }
  }
}

sth_addTest(testName, testcase);