/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
Let 'x' be the return value from getPrototypeOf when called on d.
Then, x.isPrototypeOf(d) must be true.
*/

var testName = "Object.getPrototypeOf returns the [[Prototype]] of its parameter (custom object)";

function testcase() {
  function base() {}

  function derived() {}
  derived.prototype = new base();

  var d = new derived();
  var x = Object.getPrototypeOf(d);
  if (x.isPrototypeOf(d) === true) {
    return true;
  }
}

function prereq() {
  return fnExists(Object.getPrototypeOf);
}

sth_addTest(testName, testcase, prereq);