/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

var testName = "Object.getOwnPropertyNames returns array of property names (Date.prototype)";

function testcase() {
  var result = Object.getOwnPropertyNames(Date.prototype);
  var expResult = ["constructor", "getTime", "getTimezoneOffset", "getYear", "getFullYear", "getMonth", "getDate", "getDay", "getHours", "getMinutes", "getSeconds", "getMilliseconds", "getUTCFullYear", "getUTCMonth", "getUTCDate", "getUTCDay", "getUTCHours", "getUTCMinutes", "getUTCSeconds", "getUTCMilliseconds", "setTime", "setYear", "setFullYear", "setMonth", "setDate", "setHours", "setMinutes", "setSeconds", "setMilliseconds", "setUTCFullYear", "setUTCMonth", "setUTCDate", "setUTCHours", "setUTCMinutes", "setUTCSeconds", "setUTCMilliseconds", "toLocaleString", "toString", "toUTCString", "toGMTString", "toTimeString", "toDateString", "toLocaleDateString", "toLocaleTimeString", "valueOf", "toISOString", "toJSON"];
  if (compareArray(expResult, result)) {
    return true;
  }
}

function prereq() {
  return fnExists(Object.getOwnPropertyNames);
}

sth_addTest(testName, testcase, prereq);