/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
create sets the [[Prototype]] of the created object to first parameter.
This can be checked using isPrototypeOf, or getPrototypeOf.
*/
var testName = "Object.create sets the prototype of the passed-in object";

function testcase() {
    function base() {}
    var b = new base();
    var d = Object.create(b);

    if (Object.getPrototypeOf(d) === b &&
        b.isPrototypeOf(d) === true) {
      return true;
    }
}

function prereq() {
  return fnExists(Object.create) && fnExists(Object.getPrototypeOf);
}

sth_addTest(testName, testcase, prereq);