/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
The abtract operation ToPropertyDescriptor  is used to package the
into a property desc. Step 10 of ToPropertyDescriptor throws a TypeError
if the property desc ends up having a mix of accessor and data property elements.
*/
var testName = "Object.defineProperty throws TypeError if setter is not callable but not undefined (Object)";

function testcase() {
    var o = {};
    
    // dummy getter
    var setter = { a: 1 };
    var desc = { set: setter };
    
    try {
      Object.defineProperty(o, "foo", desc);
    }
    catch (e) {
      if (e instanceof TypeError &&
          (o.hasOwnProperty("foo") === false)) {
        return true;
      }
    }
}

function prereq() {
  return fnExists(Object.defineProperty);
}

sth_addTest(testName, testcase, prereq);