/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
Step 4 of defineProperty calls the [[DefineOwnProperty]] internal method
of O passing 'true' for the Throw flag. In this case, step 3 of
[[DefineOwnProperty]] requires that it throw a TypeError exception when
current is undefined and extensible is false. The value of desc does not
matter.
*/

var testName = "Object.defineProperty throws TypeError when adding properties to non-extensible objects";

function testcase() {
  var o = {};
  Object.preventExtensions(o);

  try {
    var desc = { value: 1 };
    Object.defineProperty(o, "foo", desc);
  }
  catch (e) {
      if (e instanceof TypeError &&
          (o.hasOwnProperty("foo") === false)) {
      return true;
    }
  }
}

function prereq() {
  return fnExists(Object.defineProperty) && fnExists(Object.preventExtensions);
}

sth_addTest(testName, testcase, prereq);