/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
When invoked using [[Call]] with an object that does not implement valueOf
as a function, the attempt in step 4 to [[Call]] it should fail, throwing
a TypeError exception.
*/

var testName = "String.prototype.toJSON(key) called as a method - custom object with valueOf that is not callable - throws TypeError";

function testcase() {
  var o = { valueOf : false };
  try {
    String.prototype.toJSON.call(o, 0);
  }
  catch (e) {
    if (e instanceof TypeError) {
      return true;
    }
  }
}

function prereq() {
  return fnExists(String.prototype.toJSON);
}

sth_addTest(testName, testcase, prereq);