/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
When invoked as a function, "this" is bound to the global object.
"valueOf" on the global object returns itself. In step 4, calling it
again using [[Call]] will still return the same object; step 5 will
fail causing step 6 to throw an TypeError exception.
*/

var testName = "Boolean.prototype.toJSON(key) called as a function - global obj's valueOf - throws TypeError";

function testcase() {
    try {
      Boolean.prototype.toJSON(0);
    }
    catch (e) {
      if (e instanceof TypeError) {
        return true;
      }
    }
}

function prereq() {
  return fnExists(Boolean.prototype.toJSON);
}

sth_addTest(testName, testcase, prereq);