/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
When invoked as a function, "this" is bound to the global object.
"valueOf" on the global object returns itself. We provide an
override for valueOf that returns the primitive value 1. In step 4,
calling it again using [[Call]] should return this primitive value.

Refer section 2.5 from the JScript Deviations document. IE cannot see
valueOf as added to the global object. But that is a separate bug.
*/

var testName = "Boolean.prototype.toJSON(key) called as a function - global obj's valueOf overridden to return prim value - returns prim value";

this.valueOf = function () {
  return 1;
}

function testcase() {
    try {
      var v = Boolean.prototype.toJSON(0);
      if (v === 1) {
        return true;
      }
    }
    catch (e) {
      // no exception must be thrown.
    }
    finally {
      delete this.valueOf;
    }
}

function prereq() {
  return fnExists(Boolean.prototype.toJSON);
}

sth_addTest(testName, testcase, prereq);