/// Copyright (c) Microsoft Corporation. 
/// 
/// The contents of this file are subject to the terms of the New BSD License. 
/// You may obtain a copy of the License at http://es5conformm.codeplex.com/license 
/// 
/// Alternatively the contents of this file may be used under the terms of the Microsoft Public License. 
/// You may obtain a copy of the License at http://www.microsoft.com/opensource/licenses.mspx#Ms-PL 

/*
When invoked using [[Call]] with an object that implements valueOf
that returns an object, step 5 should fail, causing a step 6 to throw
a TypeError exception.
*/

var testName = "Number.prototype.toJSON(key) called as a method - custom object with valueOf returning an object - throws a TypeError";

function testcase() {
  var o = { valueOf : function () { return new Boolean(false);} };

  try {
    Number.prototype.toJSON.call(o, 0);
  }
  catch (e) {
    if (e instanceof TypeError) {
      return true;
    }
  }
}

function prereq() {
  return fnExists(Number.prototype.toJSON);
}

sth_addTest(testName, testcase, prereq);